## nvidia-graphics-drivers-515 515.105.01

=== Makefile ===
###########################################################################
# This is the top level makefile for the NVIDIA Linux kernel module source
# package.
#
# To build: run `make modules`
# To install the build kernel modules: run (as root) `make modules_install`
###########################################################################

include utils.mk

all: modules

nv_kernel_o                = src/nvidia/$(OUTPUTDIR)/nv-kernel.o
nv_kernel_o_binary         = kernel-open/nvidia/nv-kernel.o_binary

nv_modeset_kernel_o        = src/nvidia-modeset/$(OUTPUTDIR)/nv-modeset-kernel.o
nv_modeset_kernel_o_binary = kernel-open/nvidia-modeset/nv-modeset-kernel.o_binary

.PHONY: $(nv_kernel_o) $(nv_modeset_kernel_o) modules modules_install


###########################################################################
# nv-kernel.o is the OS agnostic portion of nvidia.ko
###########################################################################

$(nv_kernel_o):
	$(MAKE) -C src/nvidia

$(nv_kernel_o_binary): $(nv_kernel_o)
	cd $(dir $@) && ln -sf ../../$^ $(notdir $@)


###########################################################################
# nv-modeset-kernel.o is the OS agnostic portion of nvidia-modeset.ko
###########################################################################

$(nv_modeset_kernel_o):
	$(MAKE) -C src/nvidia-modeset

$(nv_modeset_kernel_o_binary): $(nv_modeset_kernel_o)
	cd $(dir $@) && ln -sf ../../$^ $(notdir $@)


###########################################################################
# After the OS agnostic portions are built, descend into kernel-open/ and build
# the kernel modules with kbuild.
###########################################################################

modules: $(nv_kernel_o_binary) $(nv_modeset_kernel_o_binary)
	$(MAKE) -C kernel-open modules


###########################################################################
# Install the built kernel modules using kbuild.
###########################################################################

modules_install:
	$(MAKE) -C kernel-open modules_install


###########################################################################
# clean
###########################################################################

.PHONY: clean nvidia.clean nvidia-modeset.clean kernel-open.clean

clean: nvidia.clean nvidia-modeset.clean kernel-open.clean

nvidia.clean:
	$(MAKE) -C src/nvidia clean

nvidia-modeset.clean:
	$(MAKE) -C src/nvidia-modeset clean

kernel-open.clean:
	$(MAKE) -C kernel-open clean

## nvidia-graphics-drivers-515 515.48.07

=== debian/changelog ===
nvidia-graphics-drivers-515 (515.48.07-0ubuntu0.21.10.2) impish; urgency=medium

  * debian/templates/control.in:
    - Drop transitional packages for 495.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 23 Jun 2022 18:08:29 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu0.21.10.1) impish; urgency=medium

  [ Alberto Milone ]
  * Initial release (LP: #1976425).

 -- Ian May <ian.may@canonical.com>  Thu, 02 Jun 2022 00:37:27 -0500

=== debian/control ===
Source: nvidia-graphics-drivers-515
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders:
 Alberto Milone <alberto.milone@canonical.com>,
Vcs-Git: git://github.com/tseliot/nvidia-graphics-drivers.git
Vcs-Browser: https://github.com/tseliot/nvidia-graphics-drivers/tree/515
Build-Depends:
 debhelper (>= 9),
 dpkg-dev (>= 1.17.11~),
 xz-utils,
 dkms,
 libxext6,
 quilt,
 po-debconf,
 execstack,
 dh-modaliases,
 xserver-xorg-dev (>= 2:1.4),
 libglvnd-dev,
 libkmod-dev,
 libpciaccess-dev,
 pkg-config,
 libnvidia-egl-wayland1,
 libc6,
 libx11-6,
 python3,
Standards-Version: 4.1.1
Homepage: http://www.nvidia.com
XS-Autobuild: yes

Package: nvidia-driver-515
Architecture: amd64
Depends:
 libnvidia-gl-515 (= ${binary:Version}),
 nvidia-dkms-515 (<= 515.48.07-1),
 nvidia-dkms-515 (>= 515.48.07),
 nvidia-kernel-common-515 (<= 515.48.07-1),
 nvidia-kernel-common-515 (>= 515.48.07),
 nvidia-kernel-source-515 (= ${binary:Version}),
 libnvidia-compute-515 (= ${binary:Version}),
 libnvidia-extra-515 (= ${binary:Version}),
 nvidia-compute-utils-515 (= ${binary:Version}),
 libnvidia-decode-515 (= ${binary:Version}),
 libnvidia-encode-515 (= ${binary:Version}),
 nvidia-utils-515 (= ${binary:Version}),
 xserver-xorg-video-nvidia-515 (= ${binary:Version}),
 libnvidia-cfg1-515 (= ${binary:Version}),
 libnvidia-fbc1-515 (= ${binary:Version}) [!ppc64el],
 ${misc:Depends}
Recommends:
 nvidia-settings, nvidia-prime (>= 0.8),
 libnvidia-compute-515:i386 (= ${binary:Version}) [amd64],
 libnvidia-decode-515:i386 (= ${binary:Version}) [amd64],
 libnvidia-encode-515:i386 (= ${binary:Version}) [amd64],
 libnvidia-fbc1-515:i386 (= ${binary:Version}) [amd64],
 libnvidia-gl-515:i386 (= ${binary:Version}) [amd64]
XB-Modaliases: ${modaliases}
XB-PmAliases: ${nvidia:pm-modaliases}
XB-Support: PB
Description: NVIDIA driver metapackage
 This metapackage depends on the NVIDIA binary driver and on all of its libraries,
 to provide hardware acceleration for OpenGL/GLX/EGL/GLES/Vulkan
 applications on either X11 or on Wayland.
 .
 See /usr/share/doc/nvidia-driver-515/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: nvidia-kernel-source-515
Architecture: amd64
Multi-Arch: foreign
Conflicts:
 nvidia-kernel-source
Replaces:
 nvidia-kernel-source, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides:
 nvidia-kernel-source
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA kernel source package
 This package provides the NVIDIA kernel source needed by the userspace
 driver.

Package: nvidia-dkms-515
Architecture: amd64
Multi-Arch: foreign
Conflicts:
 nvidia-dkms-kernel
Breaks: nvidia-kernel-source-515 (<< 390.25-0ubuntu2~)
Replaces:
 nvidia-dkms-kernel, nvidia-kernel-source-515 (<< 390.25-0ubuntu2~), nvidia-384 (<< 390.25)
Provides:
 nvidia-dkms-kernel
Depends:
 dkms,
 nvidia-kernel-source-515 (<= 515.48.07-1),
 nvidia-kernel-source-515 (>= 515.48.07),
 nvidia-kernel-common-515 (<= 515.48.07-1),
 nvidia-kernel-common-515 (>= 515.48.07),
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA DKMS package
 This package builds the NVIDIA kernel module needed by the userspace
 driver, using DKMS.
 Provided that you have the kernel header packages installed, the kernel
 module will be built for your running kernel, and automatically rebuilt for
 any new kernel headers that are installed.

Package: nvidia-utils-515
Architecture: amd64
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-driver-515,
Provides:
 nvidia-utils, nvidia-smi
Conflicts:
 nvidia-utils, nvidia-smi
Replaces:
 nvidia-utils, nvidia-smi
Description: NVIDIA driver support binaries
 This package contains supporting binaries for the NVIDIA driver.

Package: libnvidia-compute-515
Architecture: i386 amd64
Multi-Arch: same
Depends:
  ${misc:Depends}, ${shlibs:Depends}
Provides: libnvidia-compute, nvidia-opencl-icd, opencl-icd, libnvidia-ml1 (= ${source:Version}),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda1 (= ${source:Version})
Conflicts: libnvidia-compute, nvidia-opencl-icd,
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1
Replaces: libnvidia-compute, nvidia-opencl-icd, libnvidia-compute-515 (<< 390.25-0ubuntu2~),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1
Description: NVIDIA libcompute package
 This package provides a set of libraries which enable the NVIDIA driver
 to use GPUs for parallel general purpose computation through CUDA and
 OpenCL.

Package: nvidia-compute-utils-515
Architecture: amd64
Depends:
 libnvidia-compute-515, adduser,
 ${misc:Depends}, ${shlibs:Depends}
Provides: nvidia-compute-utils, nvidia-persistenced
Conflicts: nvidia-compute-utils, nvidia-persistenced
Replaces: nvidia-compute-utils, nvidia-persistenced
Description: NVIDIA compute utilities
 This package provides utility binaries for paraller general purpose
 computing use cases with the NVIDIA driver.
 .
 CUDA MPS is a feature that allows multiple CUDA processes to share a single
 GPU context. CUDA MPS should be transparent to CUDA programs.
 .
 CUDA MPS requires a device that supports Unified Virtual Address (UVA) and
 has compute capability SM 3.5 or higher.
 Pre-CUDA 4.0 APIs are not supported under CUDA MPS.

Package: nvidia-headless-no-dkms-515
Architecture: amd64
Conflicts: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: nvidia-384
Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Depends:
 nvidia-kernel-common-515 (<= 515.48.07-1),
 nvidia-kernel-common-515 (>= 515.48.07),
 nvidia-kernel-source-515 (= ${binary:Version}),
 libnvidia-compute-515 (= ${binary:Version}),
 nvidia-compute-utils-515 (= ${binary:Version}),
 libnvidia-cfg1-515 (= ${binary:Version}),
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage - no DKMS
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL. DKMS will not be installed, and, therefore, the kernel module
 will not be built.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-515 metapackage.

Package: nvidia-headless-515
Architecture: amd64
Conflicts: nvidia-headless
Provides: nvidia-headless
Replaces: nvidia-headless
Depends:
 nvidia-headless-no-dkms-515,
 nvidia-dkms-515,
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-515 metapackage.

Package: nvidia-kernel-common-515
Architecture: amd64
Conflicts: nvidia-kernel-common
Provides: nvidia-kernel-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Replaces:
 nvidia-dkms-515 (<< 390.48-0ubuntu3~), nvidia-kernel-common
Description: Shared files used with the kernel module
 This package installs all the optional accessory files for the NVIDIA
 kernel module.
 .
 Install this package if you want to blacklist any conflicting kernel
 modules, and if you want udev to load the the NVIDIA kernel modules,
 and to create the uvm devices automatically.

Package: libnvidia-gl-515
Architecture: i386 amd64
Multi-Arch: same
Conflicts: libnvidia-gl
Replaces: libnvidia-gl, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: libnvidia-gl, libglx-vendor, libegl-vendor
Depends:
 libnvidia-common-515, ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA OpenGL/GLX/EGL/GLES GLVND libraries and Vulkan ICD
 This package provides the NVIDIA OpenGL/GLX/EGL/GLES libraries and the
 Vulkan ICD.

Package: libnvidia-common-515
Architecture: all
Multi-Arch: foreign
Breaks: libnvidia-gl-515 (<< 390.25-0ubuntu2~)
Conflicts: libnvidia-common
Replaces: libnvidia-common, libnvidia-gl-515 (<< 390.25-0ubuntu2~)
Provides: libnvidia-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Shared files used by the NVIDIA libraries
 This package provides a set of files that are required by the NVIDIA
 libraries.

Package: libnvidia-extra-515
Architecture: i386 amd64
Multi-Arch: same
Breaks: libnvidia-common-515 (<< 440.64-0ubuntu3~)
Conflicts: libnvidia-extra
Replaces: libnvidia-extra, libnvidia-common-515 (<< 440.64-0ubuntu3~)
Provides: libnvidia-extra
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Extra libraries for the NVIDIA driver
 This package provides an additional set of libraries to be used with
 the NVIDIA driver.

Package: xserver-xorg-video-nvidia-515
Section: non-free/x11
Architecture: amd64
Depends:
 libnvidia-cfg1-515 (= ${binary:Version}),
 ${nvidia:xorgDepends},
 ${shlibs:Depends}, ${misc:Depends}
Conflicts: xorg-driver-binary, nvidia-driver-binary
Replaces: xorg-driver-binary, nvidia-driver-binary
Provides:
 xorg-driver-binary, nvidia-driver-binary,
 ${nvidia:xorgProvides}
Description: NVIDIA binary Xorg driver
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 See /usr/share/doc/nvidia-driver-515/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: libnvidia-cfg1-515
Architecture: amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-cfg1-any,
Conflicts:
 libnvidia-cfg1-any,
Replaces:
 libnvidia-cfg1-any,
Description: NVIDIA binary OpenGL/GLX configuration library
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 This package contains the libnvidia-cfg.so.1 runtime library.

Package: libnvidia-fbc1-515
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
# ${nvidia}-alternative (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-fbc1,
Conflicts:
 libnvidia-fbc1,
Replaces:
 libnvidia-fbc1,
Description: NVIDIA OpenGL-based Framebuffer Capture runtime library
 The NVIDIA OpenGL-based Framebuffer Capture (NvFBCOpenGL) library provides
 a high performance, low latency interface to capture and optionally encode an
 OpenGL framebuffer. NvFBCOpenGL is a private API that is only available to
 approved partners for use in remote graphics scenarios.
 .
 This package contains the NvFBCOpenGL runtime library.

Package: libnvidia-decode-515
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libnvidia-compute-515 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libnvidia-decode,
Replaces:
 libnvidia-decode,
Provides:
 libnvidia-decode,
Description: NVIDIA Video Decoding runtime libraries
 This package includes the NVIDIA CUDA Video Decoder (NVCUVID) library which
 provides an interface to hardware video decoding capabilities on NVIDIA GPUs with CUDA.
 .
 The package also provides a VDPAU (Video Decode and Presentation API for Unix-like
 systems) library for the NVIDIA vendor implementation.

Package: libnvidia-encode-515
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 libnvidia-encode,
Provides:
 libnvidia-encode
Replaces:
 libnvidia-encode

## nvidia-graphics-drivers-515 515.76+really.515.65.01

=== debian/changelog ===
nvidia-graphics-drivers-515 (515.76+really.515.65.01-0ubuntu1) kinetic; urgency=medium

  * Revert to the 515.65.01 version (LP: #1993041).
  * Revert "debian/templates/dkms_nvidia.conf.in: drop buildfix_kernel_6.0.patch"
  * debian/rules:
    Make sure that debian_version variable includes the full version, so that
    we depend on the correct libraries in case of release rollbacks.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 19 Oct 2022 16:18:24 +0000

nvidia-graphics-drivers-515 (515.76-0ubuntu1) kinetic; urgency=medium

  * New upstream release (LP: #1990835):
    - Turing and later: fixed possible excessive GPU power draw on an
      idle X11 or Wayland desktop when driving high resolutions or
      refresh rates.
    - Fixed a bug that caused the Xorg server to crash if an NvFBC
      capture session is started while video memory is full.
  * debian/templates/dkms_nvidia.conf.in:
    - Drop buildfix_kernel_6.0.patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 28 Sep 2022 10:57:02 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu3) kinetic; urgency=medium

  * debian/templates/dkms_nvidia.conf.in,
    debian/dkms_nvidia/patches/buildfix_kernel_6.0.patch:
    - Add support for Linux 6.0 (LP: #1988429).

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 01 Sep 2022 12:46:05 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu2) kinetic; urgency=medium

  * debian/nvidia_supported:
    - Add support for the open kernel driver using the --open argument.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 01 Aug 2022 19:55:45 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu1) kinetic; urgency=medium

  [ Alberto Milone ]
  * New upstream release (LP: #1982501).
  * debian/templates/libnvidia-compute-flavour.{install|links}.in:
    - Include the correct link to libnvidia-nvvm, which is now also available
      on i386.
  * debian/additional_card_ids:
    - Add the missing 1EB8 ID.
  * debian/copyright,
    debian/additional_card_ids_open,
    debian/rules{.defs},
    debian/templates/control.in,
    debian/templates/dkms_nvidia_open.conf.in,
    debian/templates/nvidia-dkms-flavour-open.*.in:
    - Add support for the open kernel module.

  [ Dimitri John Ledkov ]
  * debian/templates/dkms_nvidia.conf.in:
    - Disable IBT linking by default.
    - Version restrict disable_fstack-clash-protection_fcf-protection patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 29 Jul 2022 10:30:40 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu3) kinetic; urgency=medium

  [ Alberto Milone ]
  * New upstream release (LP: #1982501).
  * debian/templates/libnvidia-compute-flavour.links.in:
    - Include the correct link to libnvidia-nvvm, which is now also available
      on i386.
  * debian/additional_card_ids:
    - Add the missing 1EB8 ID.

  [ Dimitri John Ledkov ]
  * debian/templates/dkms_nvidia.conf.in:
    - Disable IBT linking by default.
    - Version restrict disable_fstack-clash-protection_fcf-protection patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 29 Jul 2022 10:15:44 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu2) kinetic; urgency=medium

  * debian/templates/control.in:
    - Drop transitional packages for 495.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 23 Jun 2022 17:03:39 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu1) kinetic; urgency=medium

  [ Alberto Milone ]
  * Initial release (LP: #1976425).

 -- Ian May <ian.may@canonical.com>  Thu, 02 Jun 2022 11:51:17 -0500

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
  libxext6,
  quilt,
  po-debconf,
- execstack,
  dh-modaliases,
  xserver-xorg-dev (>= 2:1.4),
  libglvnd-dev,
@@ -30,13 +29,13 @@
 XS-Autobuild: yes
 
 Package: nvidia-driver-515
-Architecture: amd64
+Architecture: amd64 arm64
 Depends:
  libnvidia-gl-515 (= ${binary:Version}),
- nvidia-dkms-515 (<= 515.48.07-1),
- nvidia-dkms-515 (>= 515.48.07),
- nvidia-kernel-common-515 (<= 515.48.07-1),
- nvidia-kernel-common-515 (>= 515.48.07),
+ nvidia-dkms-515 (<= 515.76+really.515.65.01-1),
+ nvidia-dkms-515 (>= 515.76+really.515.65.01),
+ nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
+ nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
  nvidia-kernel-source-515 (= ${binary:Version}),
  libnvidia-compute-515 (= ${binary:Version}),
  libnvidia-extra-515 (= ${binary:Version}),
@@ -67,7 +66,7 @@
  for a complete list of supported GPUs and PCI IDs.
 
 Package: nvidia-kernel-source-515
-Architecture: amd64
+Architecture: amd64 arm64
 Multi-Arch: foreign
 Conflicts:
  nvidia-kernel-source
@@ -82,7 +81,7 @@
  driver.
 
 Package: nvidia-dkms-515
-Architecture: amd64
+Architecture: amd64 arm64
 Multi-Arch: foreign
 Conflicts:
  nvidia-dkms-kernel
@@ -93,10 +92,10 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-515 (<= 515.48.07-1),
- nvidia-kernel-source-515 (>= 515.48.07),
- nvidia-kernel-common-515 (<= 515.48.07-1),
- nvidia-kernel-common-515 (>= 515.48.07),
+ nvidia-kernel-source-515 (<= 515.76+really.515.65.01-1),
+ nvidia-kernel-source-515 (>= 515.76+really.515.65.01),
+ nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
+ nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -106,7 +105,7 @@
  any new kernel headers that are installed.
 
 Package: nvidia-utils-515
-Architecture: amd64
+Architecture: amd64 arm64
 Depends:
  ${shlibs:Depends}, ${misc:Depends}
 Suggests:
@@ -121,7 +120,7 @@
  This package contains supporting binaries for the NVIDIA driver.
 
 Package: libnvidia-compute-515
-Architecture: i386 amd64
+Architecture: i386 amd64 arm64
 Multi-Arch: same
 Depends:
   ${misc:Depends}, ${shlibs:Depends}
@@ -147,7 +146,7 @@
  OpenCL.
 
 Package: nvidia-compute-utils-515
-Architecture: amd64
+Architecture: amd64 arm64
 Depends:
  libnvidia-compute-515, adduser,
  ${misc:Depends}, ${shlibs:Depends}
@@ -166,13 +165,13 @@
  Pre-CUDA 4.0 APIs are not supported under CUDA MPS.
 
 Package: nvidia-headless-no-dkms-515
-Architecture: amd64
+Architecture: amd64 arm64
 Conflicts: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-515 (<= 515.48.07-1),
- nvidia-kernel-common-515 (>= 515.48.07),
+ nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
+ nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
  nvidia-kernel-source-515 (= ${binary:Version}),
  libnvidia-compute-515 (= ${binary:Version}),
  nvidia-compute-utils-515 (= ${binary:Version}),
@@ -188,7 +187,7 @@
  provided by the nvidia-driver-515 metapackage.
 
 Package: nvidia-headless-515
-Architecture: amd64
+Architecture: amd64 arm64
 Conflicts: nvidia-headless
 Provides: nvidia-headless
 Replaces: nvidia-headless
@@ -205,7 +204,7 @@
  provided by the nvidia-driver-515 metapackage.
 
 Package: nvidia-kernel-common-515
-Architecture: amd64
+Architecture: amd64 arm64
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
@@ -221,7 +220,7 @@
  and to create the uvm devices automatically.
 
 Package: libnvidia-gl-515
-Architecture: i386 amd64
+Architecture: i386 amd64 arm64
 Multi-Arch: same
 Conflicts: libnvidia-gl
 Replaces: libnvidia-gl, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
@@ -246,7 +245,7 @@
  libraries.
 
 Package: libnvidia-extra-515
-Architecture: i386 amd64
+Architecture: i386 amd64 arm64
 Multi-Arch: same
 Breaks: libnvidia-common-515 (<< 440.64-0ubuntu3~)
 Conflicts: libnvidia-extra
@@ -260,7 +259,7 @@
 
 Package: xserver-xorg-video-nvidia-515
 Section: non-free/x11
-Architecture: amd64
+Architecture: amd64 arm64
 Depends:
  libnvidia-cfg1-515 (= ${binary:Version}),
  ${nvidia:xorgDepends},
@@ -279,7 +278,7 @@
  for a complete list of supported GPUs and PCI IDs.
 
 Package: libnvidia-cfg1-515
-Architecture: amd64
+Architecture: amd64 arm64
 Multi-Arch: same
 Pre-Depends:
  ${misc:Pre-Depends}
@@ -299,7 +298,7 @@
  This package contains the libnvidia-cfg.so.1 runtime library.
 
 Package: libnvidia-fbc1-515
-Architecture: i386 amd64
+Architecture: i386 amd64 arm64
 Multi-Arch: same
 Pre-Depends:
  ${misc:Pre-Depends}
@@ -321,7 +320,7 @@
  This package contains the NvFBCOpenGL runtime library.
 
 Package: libnvidia-decode-515
-Architecture: i386 amd64
+Architecture: i386 amd64 arm64
 Multi-Arch: same
 Pre-Depends:
  ${misc:Pre-Depends}
@@ -341,16 +340,3 @@
  The package also provides a VDPAU (Video Decode and Presentation API for Unix-like
  systems) library for the NVIDIA vendor implementation.
 
-Package: libnvidia-encode-515
-Architecture: i386 amd64
-Multi-Arch: same
-Pre-Depends:
- ${misc:Pre-Depends}
-Depends:
- ${shlibs:Depends}, ${misc:Depends}
-Conflicts:
- libnvidia-encode,
-Provides:
- libnvidia-encode
-Replaces:
- libnvidia-encode

## nvidia-graphics-drivers-515 515.105.01

=== debian/changelog ===
nvidia-graphics-drivers-515 (515.105.01-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2012529).
  * debian/templates/control.in:
    - Add Conflicts, Replaces, Provides up to libcuda-11.7-1.
    - Switch to libcuda.so.1 and libnvidia-ml.so.1 provides.

 -- Alberto Milone <alberto.milone@canonical.com>  Mon, 27 Mar 2023 10:15:38 +0000

nvidia-graphics-drivers-515 (515.86.01-0ubuntu0.22.04.1) jammy; urgency=medium

  * debian/templates/dkms_nvidia.conf.in:
    - Drop buildfix_kernel_6.0.patch.
  * New upstream release (LP: #1997087).

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 22 Nov 2022 16:10:46 +0000

nvidia-graphics-drivers-515 (515.76+really.515.65.01-0ubuntu0.22.04.2) jammy; urgency=medium

  * Actually revert "debian/templates/dkms_nvidia.conf.in: drop buildfix_kernel_6.0.patch"
    (LP: #1993041).

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 25 Oct 2022 08:25:20 +0000

nvidia-graphics-drivers-515 (515.76+really.515.65.01-0ubuntu0.22.04.1) jammy; urgency=medium

  * Revert to the 515.65.01 version (LP: #1993041).
  * Revert "debian/templates/dkms_nvidia.conf.in: drop buildfix_kernel_6.0.patch"
  * debian/rules:
    Make sure that debian_version variable includes the full version, so that
    we depend on the correct libraries in case of release rollbacks.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 20 Oct 2022 09:24:39 +0000

nvidia-graphics-drivers-515 (515.76-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #1990835):
    - Turing and later: fixed possible excessive GPU power draw on an
      idle X11 or Wayland desktop when driving high resolutions or
      refresh rates.
    - Fixed a bug that caused the Xorg server to crash if an NvFBC
      capture session is started while video memory is full.
  * debian/templates/dkms_nvidia.conf.in:
    - Drop buildfix_kernel_6.0.patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Wed, 28 Sep 2022 12:33:06 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu0.22.04.3) jammy; urgency=medium

  * debian/copyright,
    debian/additional_card_ids_open,
    debian/rules{.defs},
    debian/templates/control.in,
    debian/templates/dkms_nvidia_open.conf.in,
    debian/templates/nvidia-dkms-flavour-open.*.in,
    debian/open-kernel/patches/disable_fstack-clash-protection_fcf-protection.patch:
    - Add support for the open kernel module (LP: #1988836).
  * debian/nvidia_supported:
    - Add support for the open kernel driver using the --open argument.

 -- Alberto Milone <alberto.milone@canonical.com>  Tue, 06 Sep 2022 10:56:59 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu0.22.04.2) jammy; urgency=medium

  * debian/templates/dkms_nvidia.conf.in,
    debian/dkms_nvidia/patches/buildfix_kernel_6.0.patch:
    - Add support for Linux 6.0 (LP: #1988429).

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 01 Sep 2022 16:03:01 +0000

nvidia-graphics-drivers-515 (515.65.01-0ubuntu0.22.04.1) jammy; urgency=medium

  [ Alberto Milone ]
  * New upstream release (LP: #1982501).
  * debian/copyright:
    - Add the licence for the open kernel source and binaries. No open module
      is actually built yet, and this is only for the original tarball.
  * debian/templates/libnvidia-compute-flavour.{install|links}.in:
    - Include the correct link to libnvidia-nvvm, which is now also available
      on i386.
  * debian/additional_card_ids:
    - Add the missing 1EB8 ID.

  [ Dimitri John Ledkov ]
  * debian/templates/dkms_nvidia.conf.in:
    - Disable IBT linking by default.
    - Version restrict disable_fstack-clash-protection_fcf-protection patch.

 -- Alberto Milone <alberto.milone@canonical.com>  Fri, 29 Jul 2022 10:34:50 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu0.22.04.2) jammy; urgency=medium

  * debian/templates/control.in:
    - Drop transitional packages for 495.

 -- Alberto Milone <alberto.milone@canonical.com>  Thu, 23 Jun 2022 18:03:34 +0000

nvidia-graphics-drivers-515 (515.48.07-0ubuntu0.22.04.1) jammy; urgency=medium

  [ Alberto Milone ]
  * Initial release (LP: #1976425).

 -- Ian May <ian.may@canonical.com>  Thu, 02 Jun 2022 00:51:28 -0500

=== debian/control ===
--- 
+++ 
@@ -32,10 +32,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-515 (= ${binary:Version}),
- nvidia-dkms-515 (<= 515.76+really.515.65.01-1),
- nvidia-dkms-515 (>= 515.76+really.515.65.01),
- nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
- nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
+ nvidia-dkms-515 (<= 515.105.01-1),
+ nvidia-dkms-515 (>= 515.105.01),
+ nvidia-kernel-common-515 (<= 515.105.01-1),
+ nvidia-kernel-common-515 (>= 515.105.01),
  nvidia-kernel-source-515 (= ${binary:Version}),
  libnvidia-compute-515 (= ${binary:Version}),
  libnvidia-extra-515 (= ${binary:Version}),
@@ -92,10 +92,10 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-515 (<= 515.76+really.515.65.01-1),
- nvidia-kernel-source-515 (>= 515.76+really.515.65.01),
- nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
- nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
+ nvidia-kernel-source-515 (<= 515.105.01-1),
+ nvidia-kernel-source-515 (>= 515.105.01),
+ nvidia-kernel-common-515 (<= 515.105.01-1),
+ nvidia-kernel-common-515 (>= 515.105.01),
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -124,22 +124,28 @@
 Multi-Arch: same
 Depends:
   ${misc:Depends}, ${shlibs:Depends}
-Provides: libnvidia-compute, nvidia-opencl-icd, opencl-icd, libnvidia-ml1 (= ${source:Version}),
+Provides: libnvidia-compute, nvidia-opencl-icd, opencl-icd, libnvidia-ml.so.1 (= ${source:Version}),
  libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
  libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
  libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
  libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
- libcuda1 (= ${source:Version})
+ libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
+ libcuda-11.7-1,
+ libcuda.so.1 (= ${source:Version})
 Conflicts: libnvidia-compute, nvidia-opencl-icd,
  libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
  libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
  libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
- libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1
+ libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
+ libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
+ libcuda-11.7-1
 Replaces: libnvidia-compute, nvidia-opencl-icd, libnvidia-compute-515 (<< 390.25-0ubuntu2~),
  libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
  libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
  libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
- libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1
+ libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
+ libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
+ libcuda-11.7-1
 Description: NVIDIA libcompute package
  This package provides a set of libraries which enable the NVIDIA driver
  to use GPUs for parallel general purpose computation through CUDA and
@@ -170,8 +176,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-515 (<= 515.76+really.515.65.01-1),
- nvidia-kernel-common-515 (>= 515.76+really.515.65.01),
+ nvidia-kernel-common-515 (<= 515.105.01-1),
+ nvidia-kernel-common-515 (>= 515.105.01),
  nvidia-kernel-source-515 (= ${binary:Version}),
  libnvidia-compute-515 (= ${binary:Version}),
  nvidia-compute-utils-515 (= ${binary:Version}),
@@ -337,6 +343,3 @@
  This package includes the NVIDIA CUDA Video Decoder (NVCUVID) library which
  provides an interface to hardware video decoding capabilities on NVIDIA GPUs with CUDA.
  .
- The package also provides a VDPAU (Video Decode and Presentation API for Unix-like
- systems) library for the NVIDIA vendor implementation.
-

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export NO_DOC_PKG_MANGLE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

include debian/rules.defs
XORG_ABI_LIST		?=
XORG_BOUND		?=

version			= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
debian_version	= $(shell echo $(DEB_VERSION_UPSTREAM))
NVIDIA_RELEASE   = $(version)
version_major		 = $(firstword $(subst ., ,$(version)))

# system libdir
libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)

flavour := $(version_major)
pkg_meta         := nvidia-driver-$(flavour)
pkg_meta_open    := $(pkg_meta)-open
pkg_driver       := nvidia-$(flavour)
xorg_driver      := xserver-xorg-video-nvidia-$(flavour)
#pkg_module       := $(shell echo "$(pkg_driver)" | sed s/\-/_/g)
pkg_module       := nvidia
pkg_kernel       := nvidia-kernel-$(flavour)

ifeq ($(DEB_HOST_ARCH),amd64)
DKMS_disabled_modules :=
amd64_only :=
amd64_excluded := \#
else
amd64_only := \#
amd64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),i386)
DKMS_disabled_modules := nvidia-uvm
i386_only :=
i386_excluded := \#
else
i386_only := \#
i386_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),armhf)
DKMS_disabled_modules := nvidia-uvm
armhf_only :=
armhf_excluded := \#
else
armhf_only := \#
armhf_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),arm64)
DKMS_disabled_modules :=
arm64_only :=
arm64_excluded := \#
else
arm64_only := \#
arm64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
DKMS_disabled_modules :=
ppc64el_only :=
ppc64el_excluded := \#
else
ppc64el_only := \#
ppc64el_excluded :=
endif

# i386 binaries are shipped in amd64
# Or could use ARCH_LIST to unpack all arches
ifeq ($(DEB_HOST_ARCH),i386)
unpack-stamp: NVIDIA-Linux-amd64
else
unpack-stamp: NVIDIA-Linux-$(DEB_HOST_ARCH)
endif

comma		 = ,
xorg_depends	 = $(foreach abi, $(XORG_ABI_LIST), xorg-video-abi-$(abi) |)
xorg_depends	+= $(comma) xserver-xorg-core $(XORG_BOUND)
xorg_provides	 = xorg-driver-video


.PHONY: prepare patch
prepare: unpack-stamp compare-copyright-license
patch: prepare

NVIDIA-Linux-%:
	sh $*/${NVIDIA_FILENAME_$*} --extract-only
	ln -s ${NVIDIA_DIRNAME_$*} $@
	ln -s $@ NVIDIA-Linux
	#gunzip $@/*.1.gz

# Unpack all architectures, we may need files from all of them.
unpack-stamp:
	dh_testdir
	#QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	ls -al
	touch $@

# Reformat the LICENSE to the format needed for debian/copyright.
LICENSE.txt: unpack-stamp
	sed -e 's/^ *//; s/ *$$//; s/^$$/./; s/^/ /;' NVIDIA-Linux/LICENSE > $@

# Compare the license in debian/copyright with the LICENSE shipped in the archive.
compare-copyright-license: LICENSE.txt
	sed -e '1,/^License: NVIDIA-graphics-drivers/d; 1,/^License: NVIDIA-graphics-drivers$$/d; /^$$\|^Comment:$$/,$$d; /^ \.$$/d' debian/copyright > copyright.tmp
	sed -e '/^ \.$$/d' LICENSE.txt > LICENSE.tmp
	diff -w copyright.tmp LICENSE.tmp
	rm -f copyright.tmp LICENSE.tmp

build-device-create:
	rm -f $(CURDIR)/debian/device-create/ub-device-create
	cd $(CURDIR)/debian/device-create/ && $(MAKE) all || exit 1
	@echo "ub-device-create built"

%:
	dh $@

override_dh_auto_clean:
	rm -fr .pc
	rm -f NVIDIA-Linux
	rm -fr $(foreach a,$(ARCH_LIST),NVIDIA-Linux-$a $(NVIDIA_DIRNAME_$a))
	rm -fr kernel-source-tree
	rm -f nvidia.ids nv-kernel.ids nv-readme.ids pci.ids.nvidia*
	rm -f debian/runtimepm_ids
	rm -f LICENSE.txt LICENSE.tmp copyright.tmp
	test ! -d debian/po || debconf-updatepo
	rm -f debian/$(pkg_driver).substvars
	rm -f debian/dkms.conf
	rm -f debian/device-create/ub-device-create

override_dh_clean: regen-from-templates
	dh_clean

override_dh_auto_configure: prepare regen-from-templates

override_dh_compress:
	dh_compress -Xsupported-gpus.json

override_dh_install: generate-modaliases build-device-create
	# Use our custom dkms.conf file
	cp -f $(CURDIR)/debian/dkms_nvidia.conf $(CURDIR)/debian/dkms.conf
	cp -f $(CURDIR)/debian/dkms_nvidia_open.conf $(CURDIR)/debian/open-kernel/dkms.conf

ifeq (,$(findstring nvidia-uvm,$(DKMS_disabled_modules)))
	# Make sure the UVM module is built
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/dkms.conf
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/open-kernel/dkms.conf
endif

	dh_install -p nvidia-compute-utils-$(version_major)
	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
	dh_systemd_enable --name=nvidia-persistenced
	dh_install -p nvidia-kernel-common-$(version_major)

	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
	dh_systemd_enable --name=nvidia-hibernate
	dh_systemd_enable --name=nvidia-resume
	dh_systemd_enable --name=nvidia-suspend

	dh_install

override_dh_installinit:
	dh_installinit --noscripts

override_dh_shlibdeps:
	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps

# Do not run dh_strip here.  The NVIDIA license says:
#
#     2.1.2 Linux/FreeBSD Exception.  Notwithstanding the foregoing terms of
#     Section 2.1.1, SOFTWARE designed exclusively for use on the Linux or
#     FreeBSD operating systems, or other operating systems derived from the
#     source code to these operating systems, may be copied and
#     redistributed, provided that the binary files thereof are not modified
#     in any way (except for unzipping of compressed files).
#
# Stripping the binary modules would constitute modifying the binary files
# in a way other than unzipping of compressed files.
override_dh_strip:
override_dh_strip_nondeterminism:

############################################################################

.PHONY: regen-from-templates
regen-from-templates:
	# Get rid of files belonging to different flavours
	for i in debian/templates/*.in; do \
		old=`echo $$i | sed -e "s|templates\/||g" | \
				sed -e "s|\.in\$$||g" | \
				sed -e "s|nvidia-graphics-drivers|nvidia-*|g" | \
				sed -e "s|flavour|*|g"`; \
		rm -f $$old; done
	# Create important strings
	for i in debian/templates/*.in; do \
		dest=`echo $$i | sed -e "s|templates\/||g" | \
				 sed -e "s|\.in\$$||g" | \
				 sed -e "s|flavour|$(flavour)|g"`; \
		sed -e "s|#LIBDIR#|$(libdir)|g"         \
			-e "s|#ARMHF_ONLY#|$(armhf_only)|g" \
			-e "s|#ARM64_ONLY#|$(arm64_only)|g" \
			-e "s|#AMD64_ONLY#|$(amd64_only)|g" \
			-e "s|#I386_ONLY#|$(i386_only)|g" \
			-e "s|#PPC64EL_ONLY#|$(ppc64el_only)|g" \
			-e "s|#ARMHF_EXCLUDED#|$(armhf_excluded)|g" \
			-e "s|#ARM64_EXCLUDED#|$(arm64_excluded)|g" \
			-e "s|#AMD64_EXCLUDED#|$(amd64_excluded)|g" \
			-e "s|#I386_EXCLUDED#|$(i386_excluded)|g" \
			-e "s|#PPC64EL_EXCLUDED#|$(ppc64el_excluded)|g" \
			-e "s|#NVEXCLUDEMODULES#|$(DKMS_disabled_modules)|g" \
			-e "s|#FLAVOUR#|$(flavour)|g" \
			-e "s|#DRIVERNAME#|$(pkg_driver)|g" \
			-e "s|#VERSION#|$(version)|g" \
			-e "s|#DEBIAN_VERSION#|$(debian_version)|g" \
			-e "s|#MODULENAME#|$(version)|g" \
			-e "s|#DEB_HOST_MULTIARCH#|$(DEB_HOST_MULTIARCH)|g" \
			$$i > $$dest;      \
	done

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-graphics-drivers-$(version_major).orig
TARBALL_BASE		?= nvidia-graphics-drivers-$(version_major)_$(NVIDIA_RELEASE).orig
TARBALL_SUFFIX		?= .tar.gz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.empty		?= $(ORIGDIR)
TARBALL.empty		?= $(TARBALL)

# $1 = arch
get_download_url	 = $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(HTTPURL_ARCHDIR_$(strip $1))/$(NVIDIA_RELEASE)/$(NVIDIA_FILENAME_$(strip $1))
get_origdir		 = $(or $(ORIGDIR.$(strip $1)),$(ORIGDIR)-$(strip $1))
get_tarball		 = $(or $(TARBALL.$(strip $1)),$(TARBALL_BASE)-$(strip $1)$(TARBALL_SUFFIX))

update-runtimepm-ids:
	python3 $(CURDIR)/debian/add-ids-to-json-db \
		NVIDIA-Linux/supported-gpus/supported-gpus.json \
		$(CURDIR)/debian/additional_runtimepm_ids \
		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json

generate-runtimepm-aliases: update-runtimepm-ids
	python3 $(CURDIR)/debian/pm-aliases-gen \
